Ruby: include/ruby/internal/intern/compar.h File Reference

Ruby 3.4.8p72 (2025-12-17 revision 995b59f66677d44767ce9faac6957e5543617ff9)

Functions
compar.h File Reference

Public APIs related to rb_mComparable. More...

`#include "ruby/internal/attr/cold.h"`
`#include "ruby/internal/attr/noreturn.h"`
`#include "ruby/internal/dllexport.h"`
`#include "ruby/internal/value.h"`
Include dependency graph for compar.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Functions
int | rb_cmpint (VALUE val, VALUE a, VALUE b)
| Canonicalises the passed `val`, which is the return value of `a <=> b`, into C's `{-1, 0, 1}`.
void | rb_cmperr (VALUE a, VALUE b)
| Raises "comparison failed" error.

## Detailed Description

Public APIs related to rb_mComparable.

Author
  Ruby developers ruby-.nosp@m.core.nosp@m.@ruby.nosp@m.-lan.nosp@m.g.org

Copyright
  This file is a part of the programming language Ruby. Permission is hereby granted, to either redistribute and/or modify this file, provided that the conditions mentioned in the file COPYING are met. Consult the file for details.

Warning
  Symbols prefixed with either `RBIMPL` or `rbimpl` are implementation details. Don't take them as canon. They could rapidly appear then vanish. The name (path) of this header file is also an implementation detail. Do not expect it to persist at the place it is now. Developers are free to move it anywhere anytime at will.

Note
  To ruby-core: remember that this header can be possibly recursively included from extension libraries written in C++. Do not expect for instance `__VA_ARGS__` is always available. We assume C99 for ruby itself but we don't assume languages of extension libraries. They could be written in C++98.

Definition in file compar.h.

## Function Documentation

## ◆ rb_cmperr()

void rb_cmperr | ( | VALUE | a,
|  | VALUE | b
| ) |  |

Raises "comparison failed" error.

Parameters

  [in] | a | Comparison LHS.
  [in] | b | Comparison RHS.

Exceptions

  rb_eArgError | `a` and `b` are not comparable each other.

Definition at line 28 of file compar.c.

## ◆ rb_cmpint()

int rb_cmpint | ( | VALUE | val,
|  | VALUE | a,
|  | VALUE | b
| ) |  |

Canonicalises the passed `val`, which is the return value of `a <=> b`, into C's `{-1, 0, 1}`.

This can be handy when you implement a callback function to pass to `qsort(3)` etc.

Parameters

  [in] | val | Return value of a space ship operator.
  [in] | a | Comparison LHS.
  [in] | b | Comparison RHS.

Exceptions

  rb_eArgError | `a` and `b` are not comparable each other.

Return values

  -1 | `val` is less than zero.
  0 | `val` is equal to zero.
  1 | `val` is greater than zero.

Definition at line 2965 of file bignum.c.